import _regeneratorRuntime from 'babel-runtime/regenerator';

var _this = this;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/* global fetch, window */
/* eslint max-params:off */
import { getPlatform, platforms } from './utils';
import { call } from 'redux-saga/effects';

var getURL = function getURL(url) {
	return window && window.url && url.indexOf('http') > -1 ? '' + window.url + url : url;
};

var getRequest = function getRequest(method, payload) {
	var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

	if (options.token) {
		options.headers = options.headers || {};
		options.headers['X-Amz-Security-Token'] = options.token;
		delete options.token;
	}

	if (payload && method.toUpperCase() !== 'GET') {
		options.body = JSON.stringify(payload);
	}

	return Object.assign({}, options, {
		headers: Object.assign({
			Accept: 'application/json',
			'Content-Type': 'application/json'
		}, options.headers || {}),
		method: method.toUpperCase()
	});
};

var api = function () {
	var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(method, url, payload, options) {
		var response, jsonResponse;
		return _regeneratorRuntime.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						if (getPlatform() === platforms.BROWSER || getPlatform() === platforms.NODE) {
							require('isomorphic-fetch');
						}

						_context.next = 3;
						return fetch(getURL(url), getRequest(method, payload, options));

					case 3:
						response = _context.sent;
						_context.next = 6;
						return response.json();

					case 6:
						jsonResponse = _context.sent;
						return _context.abrupt('return', jsonResponse);

					case 8:
					case 'end':
						return _context.stop();
				}
			}
		}, _callee, _this);
	}));

	return function api(_x2, _x3, _x4, _x5) {
		return _ref.apply(this, arguments);
	};
}();

export var del = function del(url, payload, options) {
	return call(api, 'DELETE', url, payload, options);
};
export var get = function get(url, options) {
	return call(api, 'GET', url, null, options);
};
export var post = function post(url, payload, options) {
	return call(api, 'POST', url, payload, options);
};
export var put = function put(url, payload, options) {
	return call(api, 'PUT', url, payload, options);
};
export var remove = function remove(url, payload, options) {
	return call(api, 'DELETE', url, payload, options);
};

export default {
	del: del,
	get: get,
	post: post,
	put: put,
	remove: remove
};
//# sourceMappingURL=api.js.map
